<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: vx_graph.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
<h1>vx_graph.h</h1><a href="vx__graph_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * Copyright (c) 2012-2016 The Khronos Group Inc.</span>
<a name="l00003"></a>00003 <span class="comment"> *</span>
<a name="l00004"></a>00004 <span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a</span>
<a name="l00005"></a>00005 <span class="comment"> * copy of this software and/or associated documentation files (the</span>
<a name="l00006"></a>00006 <span class="comment"> * &quot;Materials&quot;), to deal in the Materials without restriction, including</span>
<a name="l00007"></a>00007 <span class="comment"> * without limitation the rights to use, copy, modify, merge, publish,</span>
<a name="l00008"></a>00008 <span class="comment"> * distribute, sublicense, and/or sell copies of the Materials, and to</span>
<a name="l00009"></a>00009 <span class="comment"> * permit persons to whom the Materials are furnished to do so, subject to</span>
<a name="l00010"></a>00010 <span class="comment"> * the following conditions:</span>
<a name="l00011"></a>00011 <span class="comment"> *</span>
<a name="l00012"></a>00012 <span class="comment"> * The above copyright notice and this permission notice shall be included</span>
<a name="l00013"></a>00013 <span class="comment"> * in all copies or substantial portions of the Materials.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * MODIFICATIONS TO THIS FILE MAY MEAN IT NO LONGER ACCURATELY REFLECTS</span>
<a name="l00016"></a>00016 <span class="comment"> * KHRONOS STANDARDS. THE UNMODIFIED, NORMATIVE VERSIONS OF KHRONOS</span>
<a name="l00017"></a>00017 <span class="comment"> * SPECIFICATIONS AND HEADER INFORMATION ARE LOCATED AT</span>
<a name="l00018"></a>00018 <span class="comment"> *    https://www.khronos.org/registry/</span>
<a name="l00019"></a>00019 <span class="comment"> *</span>
<a name="l00020"></a>00020 <span class="comment"> * THE MATERIALS ARE PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND,</span>
<a name="l00021"></a>00021 <span class="comment"> * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF</span>
<a name="l00022"></a>00022 <span class="comment"> * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.</span>
<a name="l00023"></a>00023 <span class="comment"> * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY</span>
<a name="l00024"></a>00024 <span class="comment"> * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,</span>
<a name="l00025"></a>00025 <span class="comment"> * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE</span>
<a name="l00026"></a>00026 <span class="comment"> * MATERIALS OR THE USE OR OTHER DEALINGS IN THE MATERIALS.</span>
<a name="l00027"></a>00027 <span class="comment"> */</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#ifndef VX_GRAPH_H_</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#define VX_GRAPH_H_</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#ifdef __cplusplus</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00037"></a>00037 <span class="preprocessor">#endif</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00048"></a><a class="code" href="group__group__vx__graph__cfg.html#ga98742f4b8c0d0aefaa0e0a3b8a08c223">00048</a> <span class="preprocessor">#define TIVX_GRAPH_MAX_HEAD_NODES          (8u)</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span>
<a name="l00053"></a><a class="code" href="group__group__vx__graph__cfg.html#gaa4e83abd40c45fbd296008ad79d8d9b9">00053</a> <span class="preprocessor">#define TIVX_GRAPH_MAX_LEAF_NODES          (8u)</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>
<a name="l00058"></a><a class="code" href="group__group__vx__graph__cfg.html#ga1e90c432483f28c0c32b249577b46dde">00058</a> <span class="preprocessor">#define TIVX_GRAPH_MAX_PARAMS              (8u)</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span>
<a name="l00063"></a><a class="code" href="group__group__vx__graph__cfg.html#ga328a381d97286ef5ef025be1e9471437">00063</a> <span class="preprocessor">#define TIVX_GRAPH_MAX_DELAYS              (8u)</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>
<a name="l00068"></a><a class="code" href="structtivx__graph__t.html">00068</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>_vx_graph {
<a name="l00069"></a>00069 
<a name="l00071"></a><a class="code" href="structtivx__graph__t.html#a7f42313ffd03a9ddffb31d2b8c44759d">00071</a>     <a class="code" href="structtivx__reference__t.html" title="The most basic type in the OpenVX system. Any type that inherits from tivx_reference_t...">tivx_reference_t</a>      base;
<a name="l00072"></a>00072 
<a name="l00074"></a><a class="code" href="structtivx__graph__t.html#a3af31f843855b311dd2c24a8e41ab5d3">00074</a>     <a class="code" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0" title="A Boolean value. This allows 0 to be FALSE, as it is in C, and any non-zero to be...">vx_bool</a> verified;
<a name="l00075"></a>00075 
<a name="l00077"></a><a class="code" href="structtivx__graph__t.html#a8ab23bb35c280e55583c0e9775d1798d">00077</a>     <a class="code" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0" title="A Boolean value. This allows 0 to be FALSE, as it is in C, and any non-zero to be...">vx_bool</a> reverify;
<a name="l00078"></a>00078 
<a name="l00080"></a><a class="code" href="structtivx__graph__t.html#a696ed59e5c9f6dc5367c86f972b2cf59">00080</a>     <a class="code" href="vx__types_8h.html#a7f1b5d91fac63093ee3a77e87d942f96" title="An opaque reference to a kernel node.">vx_node</a> nodes[<a class="code" href="group__group__tivx__obj__desc.html#gaa345cc795baa95e1d5ff39694700ad87" title="Max possible nodes in graph.">TIVX_GRAPH_MAX_NODES</a>];
<a name="l00081"></a>00081 
<a name="l00082"></a>00082     <span class="comment">/* \brief Number of nodes in a graph */</span>
<a name="l00083"></a><a class="code" href="structtivx__graph__t.html#a912f3bc63d9cd2410b00ffd765abf491">00083</a>     uint32_t num_nodes;
<a name="l00084"></a>00084 
<a name="l00086"></a><a class="code" href="structtivx__graph__t.html#a753d5fbcf252f1c15f4ab2c96c0fd7c6">00086</a>     <a class="code" href="vx__types_8h.html#a7f1b5d91fac63093ee3a77e87d942f96" title="An opaque reference to a kernel node.">vx_node</a> head_nodes[<a class="code" href="group__group__vx__graph__cfg.html#ga98742f4b8c0d0aefaa0e0a3b8a08c223" title="Max possible head nodes in graph.">TIVX_GRAPH_MAX_HEAD_NODES</a>];
<a name="l00087"></a>00087 
<a name="l00088"></a>00088     <span class="comment">/* \brief Number of head nodes in a graph */</span>
<a name="l00089"></a><a class="code" href="structtivx__graph__t.html#a6cfb9ecaa87c9bed55a487bbf6f7be37">00089</a>     uint32_t num_head_nodes;
<a name="l00090"></a>00090 
<a name="l00092"></a><a class="code" href="structtivx__graph__t.html#a0c6151625a3db70de72b8ad4143b6073">00092</a>     <a class="code" href="vx__types_8h.html#a7f1b5d91fac63093ee3a77e87d942f96" title="An opaque reference to a kernel node.">vx_node</a> leaf_nodes[<a class="code" href="group__group__vx__graph__cfg.html#ga98742f4b8c0d0aefaa0e0a3b8a08c223" title="Max possible head nodes in graph.">TIVX_GRAPH_MAX_HEAD_NODES</a>];
<a name="l00093"></a>00093 
<a name="l00094"></a>00094     <span class="comment">/* \brief Number of leaf nodes in a graph */</span>
<a name="l00095"></a><a class="code" href="structtivx__graph__t.html#a45d95e11db5bbe08e3d15dc8c74de953">00095</a>     uint32_t num_leaf_nodes;
<a name="l00096"></a>00096 
<a name="l00098"></a>00098     <span class="keyword">struct </span>{
<a name="l00100"></a><a class="code" href="structtivx__graph__t.html#ae21d01a3645e1896b84e828b69cf557a">00100</a>         <a class="code" href="vx__types_8h.html#a7f1b5d91fac63093ee3a77e87d942f96" title="An opaque reference to a kernel node.">vx_node</a> node;
<a name="l00102"></a><a class="code" href="structtivx__graph__t.html#ad8dfe96274e1549c761ee11142f1739c">00102</a>         uint32_t  index;
<a name="l00103"></a>00103     } parameters[<a class="code" href="group__group__vx__graph__cfg.html#ga1e90c432483f28c0c32b249577b46dde" title="Max possible parameters in graph.">TIVX_GRAPH_MAX_PARAMS</a>];
<a name="l00105"></a><a class="code" href="structtivx__graph__t.html#a9dac3e16e891f80cf2948cc47cf51224">00105</a>     uint32_t      num_params;
<a name="l00106"></a>00106 
<a name="l00108"></a><a class="code" href="structtivx__graph__t.html#a689a9c5b613f5c3000ab731986e057ca">00108</a>     <a class="code" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85" title="Sets the standard enumeration type size to be a fixed quantity.">vx_enum</a>        state;
<a name="l00109"></a>00109 
<a name="l00111"></a><a class="code" href="structtivx__graph__t.html#a223993138f4680fa62734ffeae5b5519">00111</a>     <a class="code" href="structvx__perf__t.html" title="The performance measurement structure. The time or durations are in units of nano...">vx_perf_t</a>      perf;
<a name="l00112"></a>00112 
<a name="l00114"></a><a class="code" href="structtivx__graph__t.html#a2adfb145d230b3f36ba1e87e14f5dee3">00114</a>     <a class="code" href="vx__types_8h.html#a2c6de63476aff4a009bac8d0eb9800d1" title="The delay object. This is like a ring buffer of objects that is maintained by the...">vx_delay</a>       delays[<a class="code" href="group__group__vx__graph__cfg.html#ga328a381d97286ef5ef025be1e9471437" title="Max possible delays in graph.">TIVX_GRAPH_MAX_DELAYS</a>];
<a name="l00115"></a>00115 
<a name="l00117"></a><a class="code" href="structtivx__graph__t.html#a4a34b5faf7a0efe3107d19c5c44bf6ad">00117</a>     <a class="code" href="structvx__rectangle__t.html" title="The rectangle data structure that is shared with the users. The area of the rectangle...">vx_rectangle_t</a> in_valid_rect[<a class="code" href="group__group__tivx__obj__desc__cfg.html#ga4cc5e19e782439d7422fd08f47c17b09" title="Max parameters in a kernel.">TIVX_KERNEL_MAX_PARAMS</a>];
<a name="l00118"></a>00118 
<a name="l00120"></a><a class="code" href="structtivx__graph__t.html#a56cb0985d8f8c6c3f07e6121223dd7f7">00120</a>     <a class="code" href="structvx__rectangle__t.html" title="The rectangle data structure that is shared with the users. The area of the rectangle...">vx_rectangle_t</a> *in_valid_rect_ptr[<a class="code" href="group__group__tivx__obj__desc__cfg.html#ga4cc5e19e782439d7422fd08f47c17b09" title="Max parameters in a kernel.">TIVX_KERNEL_MAX_PARAMS</a>];
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00124"></a><a class="code" href="structtivx__graph__t.html#a71d84165dc249dc246575e10ae524d8e">00124</a>     <a class="code" href="structvx__rectangle__t.html" title="The rectangle data structure that is shared with the users. The area of the rectangle...">vx_rectangle_t</a> out_valid_rect[<a class="code" href="group__group__tivx__obj__desc__cfg.html#ga9394c906b6f2581dcbfe1b830d31eee5" title="Maximum number of objects supported in pyramid.">TIVX_PYRAMID_MAX_LEVEL_OBJECTS</a>];
<a name="l00125"></a>00125 
<a name="l00127"></a><a class="code" href="structtivx__graph__t.html#a162ec377600e281973558b4fa4d5c429">00127</a>     <a class="code" href="structvx__rectangle__t.html" title="The rectangle data structure that is shared with the users. The area of the rectangle...">vx_rectangle_t</a> *out_valid_rect_ptr[<a class="code" href="group__group__tivx__obj__desc__cfg.html#ga9394c906b6f2581dcbfe1b830d31eee5" title="Maximum number of objects supported in pyramid.">TIVX_PYRAMID_MAX_LEVEL_OBJECTS</a>];
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 } <a class="code" href="structtivx__graph__t.html" title="The top level data for graph object.">tivx_graph_t</a>;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00142"></a>00142 int32_t <a class="code" href="group__group__vx__graph.html#ga382c7c56a26c11ef3ab4d53ee067a801" title="Get next free node entry in graph.">ownGraphGetFreeNodeIndex</a>(<a class="code" href="vx__types_8h.html#a7e71c08b1777e49abaf4417506ca8451" title="An opaque reference to a graph.">vx_graph</a> graph);
<a name="l00143"></a>00143 
<a name="l00157"></a>00157 <a class="code" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0" title="A formal status type with known fixed size.">vx_status</a> <a class="code" href="group__group__vx__graph.html#ga3cdd9e3db44e005e8f327756fd47d9dc" title="Add&amp;#39;s a node to a graph.">ownGraphAddNode</a>(<a class="code" href="vx__types_8h.html#a7e71c08b1777e49abaf4417506ca8451" title="An opaque reference to a graph.">vx_graph</a> graph, <a class="code" href="vx__types_8h.html#a7f1b5d91fac63093ee3a77e87d942f96" title="An opaque reference to a kernel node.">vx_node</a> node, int32_t index);
<a name="l00158"></a>00158 
<a name="l00168"></a>00168 <a class="code" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0" title="A formal status type with known fixed size.">vx_status</a> <a class="code" href="group__group__vx__graph.html#ga9830a8a2a45de2cdc01865061fb59ed8" title="Remove a node from a graph.">ownGraphRemoveNode</a>(<a class="code" href="vx__types_8h.html#a7e71c08b1777e49abaf4417506ca8451" title="An opaque reference to a graph.">vx_graph</a> graph, <a class="code" href="vx__types_8h.html#a7f1b5d91fac63093ee3a77e87d942f96" title="An opaque reference to a kernel node.">vx_node</a> node);
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00181"></a>00181 <span class="keywordtype">void</span> <a class="code" href="group__group__vx__graph.html#gadccdfaff993b98451a9d159c96e8cbf4" title="Perform topological sort of graph nodes.">ownGraphTopologicalSort</a>(<a class="code" href="structtivx__graph__sort__context.html" title="Context used while sorting a graph.">tivx_graph_sort_context</a> *context, <a class="code" href="vx__types_8h.html#a7f1b5d91fac63093ee3a77e87d942f96" title="An opaque reference to a kernel node.">vx_node</a> *nodes, uint32_t num_nodes, <a class="code" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0" title="A Boolean value. This allows 0 to be FALSE, as it is in C, and any non-zero to be...">vx_bool</a> *has_cycle);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00187"></a>00187 <span class="keywordtype">void</span> <a class="code" href="group__group__vx__graph.html#ga8f66ba30fd30e78b86621bafd1b5b04c" title="Mark graph to be reverified.">ownGraphSetReverify</a>(<a class="code" href="vx__types_8h.html#a7e71c08b1777e49abaf4417506ca8451" title="An opaque reference to a graph.">vx_graph</a> graph);
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="preprocessor">#ifdef __cplusplus</span>
<a name="l00190"></a>00190 <span class="preprocessor"></span>}
<a name="l00191"></a>00191 <span class="preprocessor">#endif</span>
<a name="l00192"></a>00192 <span class="preprocessor"></span>
<a name="l00193"></a>00193 <span class="preprocessor">#endif</span>
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
